import { ReactNode, HTMLAttributes } from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
export interface BaseChipProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * If `true`, adds an error notification to the chip.
     */
    readonly error?: boolean;
    /**
     * If `true`, the chip will be disabled.
     */
    readonly disabled?: boolean;
    /**
     * Component to render inside the chip.
     */
    readonly component: ReactNode;
}
export declare const BaseChip: import("react").ForwardRefExoticComponent<BaseChipProps & import("react").RefAttributes<HTMLDivElement>>;
export {};
