import { ReactNode, HTMLAttributes, FC } from 'react';
export * from './ArrowIcon';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
export interface ExpandableProps extends Omit<BaseProps, 'children'> {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * If `true`, the body is expanded.
     * Default `false`
     */
    readonly initialExpanded?: boolean;
    readonly children: {
        readonly header: (expanded: boolean) => ReactNode;
        readonly body: ReactNode;
    };
}
export declare const Expandable: FC<ExpandableProps>;
