"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextInputField = exports.TextInputCredentialsField = exports.TextInputCredentials = exports.TextInput = exports.NumberInputField = exports.NumberInput = void 0;
var _react = require("react");
var _styledComponents = _interopRequireWildcard(require("styled-components"));
var _designparams = require("../designparams");
var _Icon = require("../Icon");
var _withField = require("../utils/withField");
var _Typography = require("../Typography");
var _Tooltip = require("../Tooltip");
var _icons = require("./icons");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["onChange", "onValueChange", "onPressEnter", "onPressEscape", "disabled", "compact", "width", "error", "errorVariant", "type", "className", "onKeyUp", "inputRef"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var getWidth = width => {
  switch (width) {
    case 'small':
      return '160px';
    case 'medium':
      return '200px';
    case 'large':
      return '352px';
    case 'full':
      return '100%';
    default:
      return '100%';
  }
};
var Error = _styledComponents.default.div.withConfig({
  displayName: "Input__Error",
  componentId: "sc-5z5y11-0"
})(["color:", ";line-height:16px;background-color:transparent;display:flex;align-items:center;position:absolute;left:0;right:0;bottom:0;top:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.elementError();
}, _ref2 => {
  var {
    compact
  } = _ref2;
  return !compact ? _designparams.componentSize.medium : _designparams.componentSize.small;
});
var ErrorLineContainer = _styledComponents.default.div.withConfig({
  displayName: "Input__ErrorLineContainer",
  componentId: "sc-5z5y11-1"
})(["position:relative;box-sizing:border-box;border-bottom:1px solid ", ";height:100%;min-width:", ";flex-grow:1;"], _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.elementError();
}, _designparams.spacing.medium);
var ErrorLine = _styledComponents.default.div.withConfig({
  displayName: "Input__ErrorLine",
  componentId: "sc-5z5y11-2"
})(["position:absolute;bottom:-1px;height:2px;width:100%;background-color:transparent;border-radius:", ";"], _ref4 => {
  var {
    hasErrorMessage
  } = _ref4;
  return hasErrorMessage ? "".concat(_designparams.shape.radius.small, " 0 0 0") : "".concat(_designparams.shape.radius.small, " ").concat(_designparams.shape.radius.small, " 0 0");
});
var ErrorMessage = _styledComponents.default.div.withConfig({
  displayName: "Input__ErrorMessage",
  componentId: "sc-5z5y11-3"
})(["padding:0 ", ";position:relative;bottom:-50%;overflow:hidden;text-overflow:ellipsis;cursor:text;"], _designparams.spacing.medium);
var FocusLine = _styledComponents.default.div.withConfig({
  displayName: "Input__FocusLine",
  componentId: "sc-5z5y11-4"
})(["position:absolute;bottom:-2px;height:2px;width:100%;background-color:transparent;border-radius:", " ", " 0 0;"], _designparams.shape.radius.small, _designparams.shape.radius.small);
var InputContainer = _styledComponents.default.div.withConfig({
  displayName: "Input__InputContainer",
  componentId: "sc-5z5y11-5"
})(["position:relative;display:inline-flex;width:", ";background-color:", ";box-sizing:border-box;border-width:0;border-bottom:1px solid ", ";border-radius:", " ", " 0 0;height:", ";&:hover{border-bottom:1px solid ", ";background-color:", ";}&:focus-within{outline:none;border-bottom:2px solid transparent;background-color:", ";}&:focus-within ", "{background-color:", ";}&:focus-within ", "{background-color:", ";}&:focus-within ", "{border-bottom:1px solid transparent;}", " ", ";"], _ref5 => {
  var {
    width
  } = _ref5;
  return getWidth(width);
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.background02();
}, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.element11();
}, _designparams.shape.radius.medium, _designparams.shape.radius.medium, _ref8 => {
  var {
    compact
  } = _ref8;
  return !compact ? _designparams.componentSize.medium : _designparams.componentSize.small;
}, _ref9 => {
  var {
    theme
  } = _ref9;
  return theme.color.element01();
}, _ref10 => {
  var {
    theme
  } = _ref10;
  return theme.color.background01();
}, _ref11 => {
  var {
    theme
  } = _ref11;
  return theme.color.backgroundPrimary();
}, FocusLine, _ref12 => {
  var {
    theme
  } = _ref12;
  return theme.color.elementPrimary();
}, ErrorLine, _ref13 => {
  var {
    theme
  } = _ref13;
  return theme.color.elementError();
}, ErrorLineContainer, _ref14 => {
  var {
    disabled
  } = _ref14;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
}, _ref15 => {
  var {
    theme,
    hasError
  } = _ref15;
  return hasError ? (0, _styledComponents.css)(["background-color:", ";border-bottom:none;&:hover{background-color:", ";border-bottom:none;}&:focus-within{background-color:", ";border-bottom:none;}"], theme.color.backgroundError(), theme.color.backgroundError(), theme.color.backgroundError()) : undefined;
});
var InputNative = _styledComponents.default.input.withConfig({
  displayName: "Input__InputNative",
  componentId: "sc-5z5y11-6"
})(["font-family:", ";font-size:", ";line-height:", ";display:unset;overflow:hidden;text-overflow:ellipsis;width:100%;height:inherit;box-sizing:border-box;color:", ";background-color:transparent;border-width:0;padding:", ";outline:none;&::placeholder{color:", ";}&:read-only{opacity:", ";}", ""], _ref16 => {
  var {
    theme
  } = _ref16;
  return theme.font.family;
}, _ref17 => {
  var {
    theme
  } = _ref17;
  return theme.font.size.regular;
}, _ref18 => {
  var {
    theme
  } = _ref18;
  return theme.font.lineHeight.large;
}, _ref19 => {
  var {
    theme
  } = _ref19;
  return theme.color.text01();
}, _designparams.spacing.medium, _ref20 => {
  var {
    theme
  } = _ref20;
  return theme.color.text05();
}, _designparams.opacity[48], _ref21 => {
  var {
    type
  } = _ref21;
  return type === 'number' ? "\n    ::-webkit-outer-spin-button,\n    ::-webkit-inner-spin-button {\n      appearance: none;\n      margin: 0;\n    }\n    appearance: textfield; /* Firefox */\n  " : type === 'password' || type === 'text' ? "\n    ::-ms-reveal,\n    ::-ms-clear {\n      display: none;\n    }\n    " : undefined;
});
var PasswordToggle = _styledComponents.default.div.withConfig({
  displayName: "Input__PasswordToggle",
  componentId: "sc-5z5y11-7"
})(["display:inline-flex;align-items:center;cursor:pointer;height:inherit;padding:0 ", ";color:", ";", ":hover &{color:", ";}"], _designparams.spacing.medium, _ref22 => {
  var {
    theme
  } = _ref22;
  return theme.color.element11();
}, /* sc-selector */InputContainer, _ref23 => {
  var {
    theme
  } = _ref23;
  return theme.color.text05();
});
var ErrorIconContainer = _styledComponents.default.div.withConfig({
  displayName: "Input__ErrorIconContainer",
  componentId: "sc-5z5y11-8"
})(["display:inline-flex;align-items:center;height:inherit;padding:0 ", ";color:", ";"], _designparams.spacing.medium, _ref24 => {
  var {
    theme
  } = _ref24;
  return theme.color.elementError();
});
var ErrorMessageText = _ref25 => {
  var {
    error,
    errorVariant
  } = _ref25;
  var [hasOverflow, setHasOverflow] = (0, _react.useState)(false);
  var errorMessageRef = (0, _react.useRef)(null);
  (0, _react.useLayoutEffect)(() => {
    if (errorMessageRef.current === null) {
      return;
    }
    setHasOverflow(errorMessageRef.current.offsetHeight < errorMessageRef.current.scrollHeight || errorMessageRef.current.offsetWidth < errorMessageRef.current.scrollWidth);
  }, [errorMessageRef]);
  if (error === undefined || error === '' || errorVariant !== 'text') {
    return null;
  }
  var text = /*#__PURE__*/(0, _jsxRuntime.jsx)(ErrorMessage, {
    ref: errorMessageRef,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
      variant: "explanatory-text",
      children: error
    })
  });
  return hasOverflow ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Tooltip.Tooltip, {
    text: error,
    children: text
  }) : text;
};
function Input(_ref26) {
  var {
      onChange,
      onValueChange,
      onPressEnter,
      onPressEscape,
      disabled = false,
      compact: compactFromProps,
      width = 'full',
      error,
      errorVariant = 'text',
      type,
      className,
      onKeyUp,
      inputRef
    } = _ref26,
    props = _objectWithoutProperties(_ref26, _excluded);
  var containerRef = (0, _react.useRef)(null);
  var [showPassword, setShowPassword] = (0, _react.useState)(false);
  var {
    compact: compactFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;
  var handleKeyUp = (0, _react.useCallback)(e => {
    switch (e.key) {
      case 'Enter':
        {
          onPressEnter === null || onPressEnter === void 0 ? void 0 : onPressEnter();
          break;
        }
      case 'Esc':
      case 'Escape':
        {
          onPressEscape === null || onPressEscape === void 0 ? void 0 : onPressEscape();
          break;
        }
      default:
        onKeyUp === null || onKeyUp === void 0 ? void 0 : onKeyUp(e);
    }
  }, [onPressEnter, onPressEscape, onKeyUp]);
  var toggleShowPassword = (0, _react.useCallback)(e => {
    e.preventDefault();
    setShowPassword(oldValue => !oldValue);
  }, [setShowPassword]);
  var handleChange = (0, _react.useCallback)(e => {
    e.preventDefault();
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    if (onValueChange !== undefined) {
      if (type === 'number') {
        var newNumberValue = e.target.value;
        if (newNumberValue === '') {
          // To allow 0 to be removed while typing
          onValueChange(newNumberValue);
        } else {
          // We know that T should be number here
          onValueChange(Number(newNumberValue));
        }
      } else {
        // We know that T should be string here
        onValueChange(e.target.value);
      }
    }
  }, [onChange, onValueChange, type]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(InputContainer, {
    disabled: disabled,
    compact: compact,
    ref: containerRef,
    className: className,
    width: width,
    hasError: error !== undefined,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(InputNative, _objectSpread(_objectSpread({
      autoCapitalize: "off",
      autoComplete: "off",
      autoCorrect: "off",
      spellCheck: false,
      disabled: disabled,
      ref: inputRef
    }, props), {}, {
      type: (type === 'current-password' || type === 'new-password') && !showPassword ? 'password' : type,
      onChange: handleChange,
      onKeyUp: handleKeyUp
    })), (type === 'current-password' || type === 'new-password') && props.value !== '' ? /*#__PURE__*/(0, _jsxRuntime.jsx)(PasswordToggle, {
      onClick: toggleShowPassword,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
        icon: showPassword ? _icons.NotVisibilityIcon : _icons.VisibilityIcon,
        size: "small"
      })
    }) : null, error !== undefined && errorVariant === 'icon' ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ErrorIconContainer, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Tooltip.Tooltip, {
        text: error !== null && error !== void 0 ? error : '',
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
            icon: _icons.ErrorIcon
          })
        })
      })
    }) : null, error !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(Error, {
      compact: compact,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ErrorLineContainer, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ErrorLine, {
          hasErrorMessage: error !== ''
        })
      }), errorVariant === 'text' && error !== '' ? /*#__PURE__*/(0, _jsxRuntime.jsx)(ErrorMessageText, {
        errorVariant: errorVariant,
        error: error
      }) : null]
    }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(FocusLine, {})]
  });
}
var TextInput = props => /*#__PURE__*/(0, _jsxRuntime.jsx)(Input, _objectSpread(_objectSpread({}, props), {}, {
  type: "text"
}));
exports.TextInput = TextInput;
var NumberInput = props => /*#__PURE__*/(0, _jsxRuntime.jsx)(Input, _objectSpread(_objectSpread({}, props), {}, {
  type: "number"
}));
exports.NumberInput = NumberInput;
var TextInputCredentials = props => /*#__PURE__*/(0, _jsxRuntime.jsx)(Input, _objectSpread({}, props));
exports.TextInputCredentials = TextInputCredentials;
var TextInputField = (0, _withField.withField)(TextInput);
exports.TextInputField = TextInputField;
var NumberInputField = (0, _withField.withField)(NumberInput);
exports.NumberInputField = NumberInputField;
var TextInputCredentialsField = (0, _withField.withField)(TextInputCredentials);
exports.TextInputCredentialsField = TextInputCredentialsField;