"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Note = void 0;
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _Typography = require("../Typography");
var _Icon = require("../Icon");
var _designparams = require("../designparams");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["text", "icon"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var NoteWrapper = _styledComponents.default.div.withConfig({
  displayName: "Note__NoteWrapper",
  componentId: "sc-n4brjn-0"
})(["display:flex;justify-content:flex-start;align-items:center;color:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text03();
});
var NoteIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Note__NoteIcon",
  componentId: "sc-n4brjn-1"
})(["flex:none;align-self:flex-start;color:", ";"], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text05();
});
var NoteTextWrapper = _styledComponents.default.div.withConfig({
  displayName: "Note__NoteTextWrapper",
  componentId: "sc-n4brjn-2"
})(["margin-left:", ";"], _designparams.spacing.medium);
var Note = _ref3 => {
  var {
      text,
      icon
    } = _ref3,
    props = _objectWithoutProperties(_ref3, _excluded);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(NoteWrapper, _objectSpread(_objectSpread({}, props), {}, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(NoteIcon, {
      icon: icon
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(NoteTextWrapper, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
        variant: "default-text",
        children: text
      })
    })]
  }));
};
exports.Note = Note;