"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PlaceholderContainer = exports.LabelContainer = void 0;
exports.Select = Select;
exports.SelectField = void 0;
var _react = require("react");
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _BaseSelect = require("./BaseSelect");
var _withField = require("../utils/withField");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["value", "options", "placeholder"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var LabelContainer = _styledComponents.default.span.withConfig({
  displayName: "Select__LabelContainer",
  componentId: "sc-10ei6xa-0"
})(["overflow:hidden;text-overflow:ellipsis;user-select:none;"]);
exports.LabelContainer = LabelContainer;
var PlaceholderContainer = (0, _styledComponents.default)(LabelContainer).withConfig({
  displayName: "Select__PlaceholderContainer",
  componentId: "sc-10ei6xa-1"
})(["color:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text05();
});
exports.PlaceholderContainer = PlaceholderContainer;
function Select(_ref2) {
  var {
      value: currentValue,
      options,
      placeholder = ''
    } = _ref2,
    props = _objectWithoutProperties(_ref2, _excluded);
  var textOptions = (0, _react.useMemo)(() => options.map(_ref3 => {
    var {
      value,
      label,
      disabled
    } = _ref3;
    return {
      value,
      disabled,
      component: label
    };
  }), [options]);
  var currentLabel = (0, _react.useMemo)(() => {
    var _options$find;
    return (_options$find = options.find(_ref4 => {
      var {
        value
      } = _ref4;
      return value === currentValue;
    })) === null || _options$find === void 0 ? void 0 : _options$find.label;
  }, [currentValue, options]);
  var label = (0, _react.useMemo)(() => currentLabel === undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(PlaceholderContainer, {
    children: placeholder
  }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(LabelContainer, {
    children: currentLabel
  }), [currentLabel, placeholder]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseSelect.BaseSelect, _objectSpread({
    value: currentValue,
    options: textOptions,
    component: label
  }, props));
}
var SelectField = props => (0, _withField.withField)(Select)(props);
exports.SelectField = SelectField;