"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getXAbsolutePosition = void 0;
/**
 * Finds the x position on a horizontal line and
 * returns a number between 0 - 100 representing
 * percent.
 */
var getXAbsolutePosition = (min, max, x) => {
  if (x < min || x > max) {
    throw new Error("Invalid parameters. X (".concat(x, ") must be equal or between min (").concat(min, ") and max ").concat(max));
  }

  // How far X is from left
  var xFromLeft = x - min;

  // Total length between min and max
  var length = max - min;
  return xFromLeft / length * 100;
};
exports.getXAbsolutePosition = getXAbsolutePosition;