import { Dispatch } from 'react';
import { ActionToastCreator, HideToastHandler, ToastAction, ToastCallbacks, ProgressToastCreator, ShowToastHandler, SimpleToastCreator } from './context';
export interface SimpleToastsDurations {
    readonly success?: number;
    readonly error?: number;
    readonly warning?: number;
    readonly info?: number;
}
export declare const useToastCallbacks: (dispatch: Dispatch<ToastAction>, { success, error, warning, info }?: SimpleToastsDurations) => ToastCallbacks;
export declare const useToasts: () => {
    showToast: ShowToastHandler;
    hideToast: HideToastHandler;
    clearToasts: () => void;
    showSuccessToast: SimpleToastCreator;
    showErrorToast: SimpleToastCreator;
    showWarningToast: SimpleToastCreator;
    showInfoToast: SimpleToastCreator;
    showLoadingToast: SimpleToastCreator;
    showProgressToast: ProgressToastCreator;
    showActionToast: ActionToastCreator;
};
